library(MASS)

DGP_1=function(sn,sp,sd,c){

sd<-1
ssn<-sn+25
z_t<-matrix(0,ssn,1)
sigma_t<-matrix(1,ssn,1)
for (ii in 1:ssn)
{
eps<-rnorm(1)
sigma_t[ii+1]<-sigma_t[ii]*0.6+0.1
u_t<-sigma_t[ii+1]*eps
z_t[ii+1]<-0.8*z_t[ii]+u_t
}

z_t<-z_t[26:ssn]
alpha<-t(matrix(rep(c,sp),sn,sp))    # alpha constants
beta<-1+0.5*t(matrix(rep(z_t,sp),sn,sp))

f_t<-matrix(0,ssn,1)
h_t<-matrix(1,ssn,1)
xi_t<-matrix(1,ssn,1)
for (ii in 1:ssn)
{
eps<-rnorm(2)
xi_t[1]<-sqrt(h_t[1])*eps[1]
h_t[ii+1]=0.32+0.67*h_t[ii]+0.13*(xi_t[ii])^2
f_t[ii+1]=0.34+0.05*(f_t[ii]-0.34)+sqrt(h_t[ii+1])*eps[2]
}

f_t<-as.matrix(f_t[26:ssn])
F_t<-t(matrix(rep(f_t,sp),sn,sp))

Sigma<-matrix(,sp,sp)  
for(ii in 1:sp)
{
    Sigma[ii,]<-0.5^abs(ii-c(1:sp))
}

e_1<-matrix(rnorm(sn*sp),sn,sp)
e_2<-matrix(rnorm(sn*sp),sn,sp)*3
e<-e_1*0.9+e_2*0.1
V<-eigen(Sigma)$vectors
D<-eigen(Sigma)$values
Sigma_root<-V%*%diag(sqrt(D))%*%t(V)
error<-e%*%Sigma_root

ydata<-alpha+beta*F_t+t(error)

ydata<-t(ydata)

return(list(ydata,f_t,Sigma))

}
