library(MASS)

DGP_2=function(sn,sp,sd,c){

sd<-3
ssn<-sn+25
z_t<-matrix(0,ssn,1)
sigma_t<-matrix(1,ssn,1)
for (ii in 1:(ssn-1))
{
eps<-rnorm(1)
sigma_t[ii+1]<-sigma_t[ii]*0.6+0.1
u_t<-sigma_t[ii+1]*eps
z_t[ii+1]<-0.8*z_t[ii]+u_t
}

z_t<-z_t[26:ssn]
alpha<-t(matrix(rep(c,sp),sn,sp))
beta_1<-1+0.5*t(matrix(rep(z_t,sp),sn,sp))
beta_2<-0.1+0.5*t(matrix(rep(z_t,sp),sn,sp))
beta_3<-0.2+0.4*t(matrix(rep(z_t,sp),sn,sp))

f_t<-matrix(0,ssn,3)
h_t<-matrix(1,ssn,3)
xi_t<-matrix(1,ssn,3)
vec_1<-c(0.34,0.04,0.06)
vec_2<-c(0.05,0.07,0.04)
vec_3<-c(0.32,0.33,0.26)
vec_4<-c(0.67,0.51,0.72)
vec_5<-c(0.13,0.03,0.05)
for (ii in 1:(ssn-1))
{
eps<-rnorm(6)
xi_t[1,]<-sqrt(h_t[1,])*eps[1:3]
h_t[ii+1,]<-vec_3+vec_4*h_t[ii,]+vec_5*(xi_t[ii,])^2
f_t[ii+1,]<-vec_1+vec_2*(f_t[ii,]-vec_1)+sqrt(h_t[ii+1,])*eps[4:6]
}

f_t<-f_t[26:ssn,]
Ft_1<-t(matrix(rep(t(f_t[,1]),sp),sn,sp))
Ft_2<-t(matrix(rep(t(f_t[,2]),sp),sn,sp))
Ft_3<-t(matrix(rep(t(f_t[,3]),sp),sn,sp))

Sigma<-matrix(,sp,sp)  
for(ii in 1:sp)
{
    Sigma[ii,]<-0.5^abs(ii-c(1:sp))
}
error<-mvrnorm(sn,rep(0,sp),Sigma)

ydata<-alpha+beta_1*Ft_1+beta_2*Ft_2+beta_3*Ft_3+t(error)

ydata<-t(ydata)

return(list(ydata,f_t,Sigma))

}
